/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.mospcommon.system.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.google.appengine.api.datastore.Query;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.mospcommon.system.dto.CmLaborAgreementDto;

/**
 * CM_LABOR_AGREEMENT(労使協定マスタ)のDAOクラス 。
 */
public class CmLaborAgreementDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * CM_LABOR_AGREEMENT(労使協定マスタ)。
	 */
	public static final String	TABLE				= "CM_LABOR_AGREEMENT";
	
	/**
	 * KEY_1 = AGREE_CODE(協定コード)。
	 */
	public static final String	KEY_1				= "AGREE_CODE";
	
	/**
	 * KEY_2 = AGREE_TYPE(協定種類)。
	 */
	public static final String	KEY_2				= "AGREE_TYPE";
	
	// 列名
	/**
	 * AGREE_CODE(協定コード)。
	 */
	public static final String	COL_AGREE_CODE		= "AGREE_CODE";
	/**
	 * AGREE_NAME(協定名称)。
	 */
	public static final String	COL_AGREE_TYPE		= "AGREE_TYPE";
	/**
	 * OVER_TIME_CODE(時間外協定コード)。
	 */
	public static final String	COL_OVER_TIME_CODE	= "OVER_TIME_CODE";
	/**
	 * WORK_ON_CODE(休出協定コード)。
	 */
	public static final String	COL_WORK_ON_CODE	= "WORK_ON_CODE";
	/**
	 * DELETE_FLAG(削除フラグ)。
	 */
	public static final String	COL_DELETE_FLAG		= "DELETE_FLAG";
	

	/**
	 * コンストラクタ。
	 */
	public CmLaborAgreementDao() {
		super();
		INSERT_DATE = "INSERT_DATE";
		INSERT_USER = "INSERT_USER";
		UPDATE_DATE = "UPDATE_DATE";
		UPDATE_USER = "UPDATE_USER";
	}
	
	/**
	 * 検索結果取得(DTOのList)。
	 * @return 検索結果リスト
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private List<CmLaborAgreementDto> mappingAll() throws SQLException {
		List<CmLaborAgreementDto> all = new ArrayList<CmLaborAgreementDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)。
	 * @return CM_LABOR_AGREEMENTレコード
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private CmLaborAgreementDto mapping() throws SQLException {
		CmLaborAgreementDto dto = new CmLaborAgreementDto();
		dto.setAgreeCode(rs.getString(COL_AGREE_CODE));
		dto.setAgreeType(rs.getString(COL_AGREE_TYPE));
		dto.setOverTimeCode(rs.getString(COL_OVER_TIME_CODE));
		dto.setWorkOnCode(rs.getString(COL_WORK_ON_CODE));
		dto.setDeleteFlag(rs.getInt(COL_DELETE_FLAG));
		mappingCommonInfo(dto);
		return dto;
	}
	
	/**
	 * 全データ取得。
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmLaborAgreementDto> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得。
	 * @param agreeCode 協定コード
	 * @param agreeType 協定種類
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmLaborAgreementDto findForKey(String agreeCode, String agreeType) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, agreeCode);
			setParam(index++, agreeType);
			executeQuery();
			CmLaborAgreementDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得。
	 * @param agreeCode 協定コード
	 * @param agreeType 協定種類
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmLaborAgreementDto findForUpdate(String agreeCode, String agreeType) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, agreeCode);
			setParam(index++, agreeType);
			executeQuery();
			CmLaborAgreementDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param agreeCode 協定コード
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmLaborAgreementDto> findForCondition(String agreeCode) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_AGREE_CODE);
		sb.append(" = ? ");
		this.pob.appendWhere(COL_AGREE_CODE, Query.FilterOperator.EQUAL);
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, agreeCode);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param agreeCode 協定コード
	 * @param agreeType 協定種類
	 * @param deleteFlag 削除フラグ
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmLaborAgreementDto> findForCondition(String agreeCode, String agreeType, String deleteFlag)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_AGREE_CODE);
		sb.append(" LIKE ? AND ");
		sb.append(COL_AGREE_TYPE);
		sb.append(" = ? ");
		this.pob.appendLike(COL_AGREE_CODE);
		this.pob.appendWhere(COL_AGREE_TYPE, Query.FilterOperator.EQUAL);
		if (!deleteFlag.equals("")) {
			sb.append("AND ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ? ");
			this.pob.appendWhere(COL_DELETE_FLAG, Query.FilterOperator.EQUAL);
		}
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, agreeCode + "%");
			setParam(index++, agreeType);
			if (!deleteFlag.equals("")) {
				setParam(index++, Integer.parseInt(deleteFlag));
			}
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param agreeCode 対象コード
	 * @param agreeType 対象協定種類
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmLaborAgreementDto findForAgreeType(String agreeCode, String agreeType) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append(" WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = " + MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_AGREE_CODE);
			sb.append(" = ? ");
			sb.append(" AND ");
			sb.append(COL_AGREE_TYPE);
			sb.append(" = ? ");
			this.pob.appendWhere(COL_DELETE_FLAG, Query.FilterOperator.EQUAL, MospConst.DELETE_FLAG_OFF);
			this.pob.appendWhere(COL_AGREE_CODE, Query.FilterOperator.EQUAL);
			this.pob.appendWhere(COL_AGREE_TYPE, Query.FilterOperator.EQUAL);
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, agreeCode);
			setParam(index++, agreeType);
			executeQuery();
			CmLaborAgreementDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入。
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(CmLaborAgreementDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新。
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int update(CmLaborAgreementDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getAgreeCode());
			setParam(index++, dto.getAgreeType());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除。
	 * @param dto 更新対象DTO
	 * @return int 削除結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int delete(CmLaborAgreementDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getDeleteQuery(getClass()));
			setParam(index++, dto.getAgreeCode());
			setParam(index++, dto.getAgreeType());
			executeUpdate();
			chkDelete(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定。
	 * @param dto 更新対象DTO
	 * @param isInsert 挿入文フラグ(true：挿入文、false：挿入文)
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private void setParams(CmLaborAgreementDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getAgreeCode());
		setParam(index++, dto.getAgreeType());
		setParam(index++, dto.getOverTimeCode());
		setParam(index++, dto.getWorkOnCode());
		setParam(index++, dto.getDeleteFlag());
		setCommonParams(isInsert);
	}
	
}
